#ifndef PDCP_NAMES_H
#define PDCP_NAMES_H



#define MSG_ID_INVALID 							0x2200
#define MSG_ID_GET_SYSTEM_INFO 					0x2201
#define MSG_ID_GET_SYSTEM_INFO_SUCCESS 			0x2202
#define MSG_ID_GET_SYSTEM_INFO_FAILURE 			0x2203
#define MSG_ID_GET_DEVICE_INFO 					0x2204
#define MSG_ID_GET_DEVICE_INFO_SUCCESS 			0x2205 
#define MSG_ID_GET_DEVICE_INFO_FAILURE 			0x2206
#define MSG_ID_GET_INPUT_CHANNEL_INFO 			0x2207
#define MSG_ID_GET_INPUT_CHANNEL_INFO_SUCCESS 	0x2208
#define MSG_ID_GET_INPUT_CHANNEL_INFO_FAILURE 	0x2209
#define MSG_ID_GET_OUTPUT_CHANNEL_INFO 			0x220A
#define MSG_ID_GET_OUTPUT_CHANNEL_INFO_SUCCESS 	0x220B
#define MSG_ID_GET_OUTPUT_CHANNEL_INFO_FAILURE 	0x220C
#define MSG_ID_GET_CHANNEL_LINK_INFO 			0x220D
#define MSG_ID_GET_CHANNEL_LINK_INFO_SUCCESS 	0x220E
#define MSG_ID_GET_CHANNEL_LINK_INFO_FAILURE 	0x220F

#define MSG_ID_GET_DEVICE_PARAMETER 			0x2301
#define MSG_ID_GET_DEVICE_PARAMETER_SUCCESS 	0x2302
#define MSG_ID_GET_DEVICE_PARAMETER_FAILURE 	0x2303
#define MSG_ID_SET_DEVICE_PARAMETER 			0x2304
#define MSG_ID_SET_DEVICE_PARAMETER_SUCCESS 	0x2305
#define MSG_ID_SET_DEVICE_PARAMETER_FAILURE 	0x2306
#define MSG_ID_CONFIGURE_CHANNEL_LINK 			0x2307
#define MSG_ID_CONFIGURE_CHANNEL_LINK_SUCCESS 	0x2308
#define MSG_ID_CONFIGURE_CHANNEL_LINK_FAILURE 	0x2309
#define MSG_ID_PASSTHROUGH 						0x230A
#define MSG_ID_PASSTHROUGH_SUCCESS 				0x230B
#define MSG_ID_PASSTHROUGH_FAILURE 				0x230C
#define MSG_ID_RESET 							0x230D	
#define MSG_ID_RESET_SUCCESS 					0x230E
#define MSG_ID_RESET_FAILURE 					0x230F


#define PARAM_ID_DEV_VID_PID 			1
#define PARAM_ID_DEV_SNUM				2
#define PARAM_ID_DEV_EAN13L				3
#define PARAM_ID_DEV_EAN13H				4
#define PARAM_ID_DEV_FW_HW_VER			5
#define PARAM_ID_DEV_TYPE_PROFILE		6
#define PARAM_ID_DEV_DESCRIPTOR			7
#define PARAM_ID_DEV_NODE_ID			8
#define PARAM_ID_DEV_N_CHANNELS			9
#define PARAM_ID_DEV_BEACON_INTERVAL	10
#define PARAM_ID_DEV_T_WAIT_ACK			11
#define PARAM_ID_DEV_BIND_REQ_TIMEOUT	12

#define PARAM_ID_CHAN_TYPE_PROFILE			1
#define PARAM_ID_CHAN_DESCRIPTOR			2
#define PARAM_ID_CHAN_TRANSFER_TYPE			3
#define PARAM_ID_CHAN_TRANSFER_ENABLE		4
#define PARAM_ID_CHAN_SOURCE_VID_PID		5 // input only
#define PARAM_ID_CHAN_SOURCE_SNUM_CI		6 // input only
#define PARAM_ID_CHAN_SOURCE_NODE_IDS		7 // input only
#define PARAM_ID_CHAN_SOURCE_TYPE_PROFILE 	8 // input only
#define PARAM_ID_CHAN_REQUIRED_ICHANS		9
#define PARAM_ID_CHAN_DESIRED_ICHANS		10
#define PARAM_ID_CHAN_TERMINAL_PROFILE		11 // input only
#define PARAM_ID_CHAN_NODE_ID				5 // output only



#define TYPE_OFFSET_BYTE_SIZE			15
#define TYPE_OFFSET_VALUE_TYPE			13
#define TYPE_OFFSET_CONTROL_MODE		11
#define TYPE_OFFSET_SOLE_ACCESS			9
#define TYPE_OFFSET_TERMINAL_CHANNEL	8

//#define NOPRINT

#define MILLION 				(1000000)
#define BILLION 				(1000000000)


typedef enum{NO_ACTION, OUT_VAR_FILLED, BAD_POINTER, TOO_SMALL, ERROR_CONDITION} return_code;


// typedef enum pdcp_channel_types{JOYSTICK, EMG, ELBOW_ROTATION, WRIST_ROTATION, HAND_GRIP} pdcp_channel_type; 
// typedef enum pdcp_device_types{SENSOR, CONTROL, EFFECTOR, CONTROL_EFFECTOR} pdcp_device_type;
// typedef enum pdcp_device_type_offset{SENSOR_OFFSET, CONTROL_OFFSET, EFFECTOR_OFFSET} pdcp_device_type_offset;

#define RESIZE_ARRAY(array, old_size, new_size, type) { \
	type * new_array = (type *)pdcp_malloc((new_size) * sizeof(type));\
	memcpy(new_array, array, (old_size) * sizeof(type));\
	pdcp_free(array);\
	array = new_array;\
}


// extern const uint8_t print_pos;
// extern const uint8_t print_vars;
// extern const uint8_t print_msgs;

#define PRINT_POS(POS) \
	if(print_pos) \
		printf(#POS"\n")
		
#define PRINT_POS_AUTO() \
	if(print_pos) \
		printf("%s, %d\n", __FUNCTION__, __LINE__)
	
#define PRINT_VAR(VAR, PRINT_TYPE) \
	if(print_vars) \
		printf(#VAR": %"#PRINT_TYPE"\n", (unsigned)VAR)
		
#define PRINTF_VAR(...) \
	if(print_vars) \
		printf(__VA_ARGS__)
		
#define PRINTF_MSG(...) \
	if(print_msgs) \
		printf(__VA_ARGS__)


#endif
