#include "pdcp_error.h"
#include "pdcp_names.h"
#include <errno.h>
#include <string.h>
#include <stdio.h>

void check_ret_value(int ret_value, int line_num){
	if (ret_value < 0){
		int temp_errno = errno;
		char* error_string = strerror(temp_errno);
		printf("Error on line %d: %d - %s\n", line_num, temp_errno, error_string);
	}
}

void check_return_code(return_code ret, int line_num){
	switch(ret){
		case OUT_VAR_FILLED:
			break;
		case NO_ACTION:
			printf("nothing happened, line %d\n", line_num);
			break;
		case BAD_POINTER:
			printf("error: bad or null pointer, line %d\n", line_num);
			break;
		case TOO_SMALL:
			printf("error: insufficient (too small) allocation, line %d\n", line_num);
			break;
		case ERROR_CONDITION:
			printf("error: received following error code: %d, line %d\n", pdcp_errno, line_num);
			break;
		default:
			printf("error: unspecified return code, line %d\n", line_num);
			break;
	}	
}
