#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include "pdcp_names.h"

int malloc_count = 0;

static const uint8_t print_pos = 0;
static const uint8_t print_vars = 0;
static const uint8_t print_msgs = 0;

void* pdcp_malloc(size_t size){
	
	void* new_ptr = malloc(size);
	if (new_ptr != NULL){
		malloc_count++;
		PRINT_VAR(new_ptr, X);
	}
	
//	printf("malloc: %X\n", new_ptr);
	
	return new_ptr;
}

void pdcp_free(void* ptr){
	
	if (ptr != NULL){
		malloc_count--;
		PRINT_VAR(ptr, X);
	}
	
//	printf("free: %X\n", ptr);
	
	free(ptr);
	
}

void* pdcp_realloc(void* ptr, size_t size){
	if(ptr == NULL)
		malloc_count++;
	
	void* new_ptr = realloc(ptr, size);
	
	if(new_ptr == NULL)
		malloc_count--;
		
		
	
//	printf("realloc: %X\n", ptr);
	
	return new_ptr;
}

int get_malloc_count(){
	return malloc_count;
}
