#include <time.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include "pdcp_low_level.h"
#include "pdcp_profiles.h"
#include "pdcp_run.h"
#include "pdcp_names.h"
#include "pdcp_configurations.h"


extern pdcp_system_info system_info;

void enforce_sole_access();

void setup(int autoconfig);
void loop();

void pdcp_run(int argc, char** argv){

	
	if (argc == 1){
		setup(1);
	} else if (!strcmp(argv[1], "autoconfig")){
		setup(1);
	} else if (!strcmp(argv[1], "save")){
		profiles_init();
		save_configuration(&system_info);
	} else if (!strcmp(argv[1], "print")){
		profiles_init();
		print_system_info(&system_info);
	} else if (!strcmp(argv[1], "info")){
		profiles_init();
		print_system_info_short(&system_info);
	} else if (!strcmp(argv[1], "clear")){
		profiles_init();
		for (int i = 0; i < system_info.n_channel_links; i++){
			remove_channel_link(&system_info, &system_info.channel_links[i]);
		}
	} else if (!strcmp(argv[1], "enforce")){
		profiles_init();
		enforce_sole_access();
	} else if (!strcmp(argv[1], "noautoconfig")){
		setup(0);
	}
	
	//loop();
	
	// will never return here if loop runs
	
}


void setup(int autoconfig){
	profiles_init();
	
/*	for (int i = 0; i < system_info.n_channel_links; i++){*/
/*		remove_channel_link(&system_info, &system_info.channel_links[i]);*/
/*	}*/
/*	refresh_system_info(&system_info);*/
	
	print_system_info_short(&system_info);
	printf("\n");
		
	while (!profiles_ready_to_run_first_setup()){}

	profiles_first_setup(autoconfig);
	
	
	print_system_info_short(&system_info);
	
}

void loop(){
	
	
	while (1){
		//nanosleep({.tv_sec = 0, .tv_nsec = PROFILES_DUTY_CYCLE_PERIOD_US*1000}, NULL);
		usleep(PROFILES_DUTY_CYCLE_PERIOD_US);
		
		if (profiles_duty_cycle()) 
			print_system_info(&system_info);;
		
	}
}







