//*********************************************************************
// 2011 Institute of Biomedical Engineering, UNB.
//
// FileName:        Main.h
//
// REVISION HISTORY:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author		Date      	Comments on this revision                                                                                                                                
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Y. Losier   11/08/12    MEC'11 PDCP Worshop
// A. Wilson            
//
// ADDITIONAL NOTES:
//
//*********************************************************************

#ifndef __MAIN_H__
#define __MAIN_H__

#include "p33fxxxx.h"
#include "PWM.h"




// Definition of variable addresses
#define DEE_ADDR_EMULATION_FLAG             0
#define DEE_ADDR_DEVICE_NODE_ID             1

#define DEE_CHANNEL_OFFSET                  2
#define DEE_CHANNEL_SIZE                    6

#define DEE_ADDR_SOURCE_VID                 0
#define DEE_ADDR_SOURCE_PID                 1
#define DEE_ADDR_SOURCE_SN                  2
#define DEE_ADDR_SOURCE_CHANNEL_INDEX       3
#define DEE_ADDR_SOURCE_TYPE                4
#define DEE_ADDR_SOURCE_PROFILE             5

//#define DATA_TRANSFER_ENABLE_FLAG_ADDR    2  // not saved
//#define SOURCE_DATA_CHANNEL_NODE_ID_ADDR  7  // not saved
//#define SOURCE_DEVICE_NODE_ID_ADDR        8  // not saved


//extern pdcp_parameter parameters[];


#ifndef NULL_POINTER
   #define NULL_POINTER 0
#endif


#define MICROSTICK_LED1_PIN _LATB15 

static inline void Config_Microstick_LED1_Pin() {_TRISB15 = 0;}  // output i/o for LED1

static inline void LED1_ON()       {PWM_set(2047);} //{MICROSTICK_LED1_PIN=1;}
static inline void LED1_OFF()      {PWM_set(0);} //{MICROSTICK_LED1_PIN=0;}
static inline void LED1_TOGGLE()   {PDC1 = PDC1 ? 0 : 2047;}//{MICROSTICK_LED1_PIN=~MICROSTICK_LED1_PIN;}

static inline void ClearInterruptFlags() {IFS0=0;IFS1=0;IFS2=0;IFS3=0;IFS4=0;}

extern void UpdateBarGraph(unsigned int value);

#endif




