/* 
 * File:   PDCP_parameters.h
 * Author: oyvinron
 *
 * Created on 27. mai 2013, 18:37
 */

#ifndef PDCP_PARAMETERS_H
#define	PDCP_PARAMETERS_H

#ifdef	__cplusplus
extern "C" {
#endif




//------------------------------------------------------------------------
//
// UNB Prosthetic Device Communication Protocol Parameter Addresses
//
//------------------------------------------------------------------------

#define PARAMETER_ADDRESS_DEVICE_VID_PID                              1
#define PARAMETER_ADDRESS_DEVICE_SERIAL_NUMBER                        2
#define PARAMETER_ADDRESS_DEVICE_EAN13L                               3
#define PARAMETER_ADDRESS_DEVICE_EAN13H                               4
#define PARAMETER_ADDRESS_DEVICE_FW_HW_VER                            5
#define PARAMETER_ADDRESS_DEVICE_TYPE_PROFILE                         6
#define PARAMETER_ADDRESS_DEVICE_DESCRIPTOR                           7
#define PARAMETER_ADDRESS_DEVICE_NODE_ID                              8
#define PARAMETER_ADDRESS_DEVICE_NUM_OF_DATA_CHANNELS                 9

#define PARAMETER_ADDRESS_DATA_CHANNEL_TYPE_PROFILE                   1
#define PARAMETER_ADDRESS_DATA_CHANNEL_DESCRIPTOR                     2
#define PARAMETER_ADDRESS_DATA_CHANNEL_TRANSFER_TYPE                  3
#define PARAMETER_ADDRESS_DATA_CHANNEL_TRANSFER_ENABLE_FLAG           4
#define PARAMETER_ADDRESS_DATA_CHANNEL_REQUIRED_INPUT_CHANNELS        9
#define PARAMETER_ADDRESS_DATA_CHANNEL_DESIRED_INPUT_CHANNELS         10


// If (Data Channel's Transfer Type == 1) ...
#define PARAMETER_ADDRESS_INPUT_DATA_CHANNEL_SOURCE_VID_PID           5
#define PARAMETER_ADDRESS_INPUT_DATA_CHANNEL_SOURCE_SN_CHANNEL_INDEX  6
#define PARAMETER_ADDRESS_INPUT_DATA_CHANNEL_SOURCE_NODE_IDS          7
#define PARAMETER_ADDRESS_INPUT_DATA_CHANNEL_SOURCE_TYPE_PROFILE      8
#define PARAMETER_ADDRESS_INPUT_DATA_CHANNEL_TERMINAL_PROFILE         11

// If (Data Channel's Transfer Type == 2) ...
#define PARAMETER_ADDRESS_OUTPUT_DATA_CHANNEL_NODE_ID                 5

struct pdcp_device_parameters{
    unsigned vid;
    unsigned pid;
    unsigned snum;
    unsigned type;
    unsigned profile;
    //unsigned long long EAN13;
    unsigned firmware_version;
    unsigned hardware_version;
    unsigned char node_id;
    unsigned char n_data_channels;
};

struct pdcp_input_channel_parameters{
    unsigned source_vid;
    unsigned source_pid;
    unsigned source_snum;
    unsigned char source_channel_index;
    unsigned char source_device_node_id;
    unsigned char source_channel_node_id;
    unsigned source_type;
    unsigned source_profile;
    unsigned terminal_profile;
    unsigned received_value;
    unsigned has_received_value;
};

struct pdcp_output_channel_parameters{
    unsigned char node_id;
};

struct pdcp_channel_parameters{
    unsigned type;
    unsigned profile;
    unsigned char transfer_enable_flag;
    unsigned char required_input_channels;
    unsigned char desired_input_channels;
};

typedef struct{
    unsigned char transfer_type; // use 0 for device
    //union{
        struct pdcp_device_parameters device;
        struct pdcp_channel_parameters chan;
        struct pdcp_input_channel_parameters ichan;
        struct pdcp_output_channel_parameters ochan;
    //};
} pdcp_parameters;

#define TRANSFER_TYPE_DEVICE_DUMMY  0
#define TRANSFER_TYPE_INPUT         1
#define TRANSFER_TYPE_OUTPUT        2



#define VENDOR_ID                   2
#define PRODUCT_ID                  2

#define FIRMWARE_VERSION            3
#define HARDWARE_VERSION            1







#ifdef	__cplusplus
}
#endif

#endif	/* PDCP_PARAMETERS_H */

