#include "PWM.h"
#include "p33fxxxx.h"

// 11-bit PWM resolution on all 3 channels! (Period ~ 1/30kHz with FRC_PLL16)
 void PWM_Init(void)
 {
	// This code was found here:
	// http://www.microchip.com/forums/m170613.aspx


  //TRISE = 0x00;  // make sure PWM pins are set to be outputs
  //PORTE = 0x00; // clear the outputs

  PTCONbits.PTOPS  = 0;  // PWM timer post-scale
  PTCONbits.PTCKPS = 0;  // PWM timer pre-scale
  PTCONbits.PTMOD  = 0;  // PWM operates in free-running Mode continuously

  PTMR  = 0;   // PWM counter value, start at 0

  PTPER = 1023;  // PWM Timebase period


  PWMCON1bits.PMOD3 = 1; // PWM in independent mode
  PWMCON1bits.PMOD2 = 1; // PWM in independent mode
  PWMCON1bits.PMOD1 = 1; // PWM in independent mode
  PWMCON1bits.PEN3H = 0; // PWM High pin is disabled
  PWMCON1bits.PEN2H = 0; // PWM High pin is disabled
  PWMCON1bits.PEN1H = 0; // PWM High pin is disabled
  PWMCON1bits.PEN3L = 0; // PWM Low pin disabled 
  PWMCON1bits.PEN2L = 0; // PWM Low pin disabled 
  PWMCON1bits.PEN1L = 1; // PWM Low pin enabled

  //PWMCON2 = 0x0000;  // PWM update info

  //DTCON1  = 0x0000;  // DeadTime Control

  //FLTACON = 0x0000;  // Fault A Control

  //OVDCON  = 0x0000;  // Override control info

  // Duty Cycle has a max value of 2xPeriod since output can change
  // on rising or falling edge of T_cy
  PDC1 = 0; // PWM#1 Duty Cycle register (11-bit)
  PDC2 = 0; // PWM#2 Duty Cycle register (11-bit)
  PDC3 = 0; // PWM#3 Duty Cycle register (11-bit)

  PTCONbits.PTEN   = 1;  // Enable PWM Timerbase !
 }

 void PWM_set(unsigned int value){
     PDC1 = value < 2048 ? value : 2047;
 }