//*********************************************************************
// 2011 Institute of Biomedical Engineering, UNB.
//
// FileName:        Timer.c
//
// REVISION HISTORY:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author		Date      	Comments on this revision                                                                                                                                
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Y. Losier   11/08/12    MEC'11 PDCP Worshop
// A. Wilson            
//
// ADDITIONAL NOTES:
//
//*********************************************************************

#include "p33fxxxx.h"
#include "Timer.h"

unsigned long timer1Counter=0;

signed char IncrementFlag = 1;
unsigned char barGraphValue = 0;
unsigned char barGraphTestCounter = 0;

//*******************************************************************************
//                                                                             
//    Function:       initTmr1
//    Description:    Configures Timer1 Module
//                                                                             
//*******************************************************************************
void InitTimer1(void) 
{
    StopTimer1();

    TMR1 = 0x0000;   // Clear timer 1
    PR1 = 16000;   // Interrupt every 1ms
    IFS0bits.T1IF = 0;   // Clear interrupt flag

    IEC0bits.T1IE = 1;   // Set interrupt enable bit
}
//*******************************************************************************



//*******************************************************************************
//                                                                             
//    Function:       StartTimer1
//    Description:    Starts Timer1 Module
//                                                                             
//*******************************************************************************
void StartTimer1(void)
{
   T1CONbits.TON = 1;
}
//*******************************************************************************



//*******************************************************************************
//                                                                             
//    Function:       StopTimer1
//    Description:    Stops Timer1 Module
//                                                                             
//*******************************************************************************
void StopTimer1(void)
{
   T1CONbits.TON = 0;
}
//*******************************************************************************



//*******************************************************************************
//                                                                             
//    Function:       T1 ISR
//    Description:    Handles interrupts caused Timer1 to increment the counter
//                                                                             
//*******************************************************************************
void __attribute__((interrupt, no_auto_psv)) _T1Interrupt(void)
{
   timer1Counter++;

   if ((timer1FlagCounter < timer1Counter) && (timer1Flag == 0))
   {
      timer1Flag = 1;
   }

   IFS0bits.T1IF = 0;		// clear interrupt flag
}
//*******************************************************************************


